

# AttachThingPrincipal
<a name="API_AttachThingPrincipal"></a>

Attaches the specified principal to the specified thing. A principal can be X.509 certificates, Amazon Cognito identities or federated identities.

Requires permission to access the [AttachThingPrincipal](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_AttachThingPrincipal_RequestSyntax"></a>

```
PUT /things/thingName/principals?thingPrincipalType=thingPrincipalType HTTP/1.1
x-amzn-principal: principal
```

## URI Request Parameters
<a name="API_AttachThingPrincipal_RequestParameters"></a>

The request uses the following URI parameters.

 ** [principal](#API_AttachThingPrincipal_RequestSyntax) **   <a name="iot-AttachThingPrincipal-request-principal"></a>
The principal, which can be a certificate ARN (as returned from the CreateCertificate operation) or an Amazon Cognito ID.  
Required: Yes

 ** [thingName](#API_AttachThingPrincipal_RequestSyntax) **   <a name="iot-AttachThingPrincipal-request-uri-thingName"></a>
The name of the thing.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `[a-zA-Z0-9:_-]+`   
Required: Yes

 ** [thingPrincipalType](#API_AttachThingPrincipal_RequestSyntax) **   <a name="iot-AttachThingPrincipal-request-uri-thingPrincipalType"></a>
The type of the relation you want to specify when you attach a principal to a thing.  
+  `EXCLUSIVE_THING` - Attaches the specified principal to the specified thing, exclusively. The thing will be the only thing that’s attached to the principal.
+  `NON_EXCLUSIVE_THING` - Attaches the specified principal to the specified thing. Multiple things can be attached to the principal.
Valid Values: `EXCLUSIVE_THING | NON_EXCLUSIVE_THING` 

## Request Body
<a name="API_AttachThingPrincipal_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_AttachThingPrincipal_ResponseSyntax"></a>

```
HTTP/1.1 200
```

## Response Elements
<a name="API_AttachThingPrincipal_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors
<a name="API_AttachThingPrincipal_Errors"></a>

 ** InternalFailureException **   
An unexpected error has occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request is not valid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ResourceNotFoundException **   
The specified resource does not exist.    
 ** message **   
The message for the exception.
HTTP Status Code: 404

 ** ServiceUnavailableException **   
The service is temporarily unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The rate exceeds the limit.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** UnauthorizedException **   
You are not authorized to perform this operation.    
 ** message **   
The message for the exception.
HTTP Status Code: 401

## See Also
<a name="API_AttachThingPrincipal_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iot-2015-05-28/AttachThingPrincipal) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iot-2015-05-28/AttachThingPrincipal) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iot-2015-05-28/AttachThingPrincipal) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iot-2015-05-28/AttachThingPrincipal) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iot-2015-05-28/AttachThingPrincipal) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iot-2015-05-28/AttachThingPrincipal) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iot-2015-05-28/AttachThingPrincipal) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iot-2015-05-28/AttachThingPrincipal) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iot-2015-05-28/AttachThingPrincipal) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iot-2015-05-28/AttachThingPrincipal) 